/* multipipe4.c - A pipe1-t es a pipe2-t olvassa parhuzamosan, a 
   poll() metodussal. */ 

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <poll.h>

int main(void) 
{
  int fds[2];
  char buf[2048];
  int i, res;
  struct pollfd pollset[2];
  int numpoll=2;
  
  /* Olvasasra megnyitjuk a pipe1 es pipe2 allomanyokat, ha 
     leteznek. */
  if((fds[0]=open("pipe1", O_RDONLY | O_NONBLOCK)) < 0)
  {
    perror("open pipe1");
    return 1;
  }
  if((fds[1]=open("pipe2", O_RDONLY | O_NONBLOCK)) < 0)
  {
    perror("open pipe2");
    return 1;
  }
  /* A ket leirot elhelyezzuk a listaban. */
  pollset[0].fd = fds[0];
  pollset[0].events = POLLIN;
  pollset[1].fd = fds[1];
  pollset[1].events = POLLIN;
  while(1)
  {
    /* A poll fuggveny varakozik az esemenyre */  
    if(poll(pollset, numpoll, -1) < 0)
    {
      perror("poll");
      return 1;
    } 
    /* Ellenorizzuk mely leiro tartalmaz olvashato adatot. */
    for(i=0; i < numpoll; i++)
    {
      //error check
      if(pollset[i].revents & (POLLERR|POLLNVAL)) 
      {
        printf("Hiba a muveletben vagy ervenytelen allomanyleiro\n");
        return 1;
      }
      if(pollset[i].revents & POLLHUP)
      {
        printf("A pipe%d lezarult\n", i+1);
        return 0;
      }
      if(pollset[i].revents & POLLIN)
      {
        /* Az fds[i] olvashato, ezert olvassuk is. */
        res = read(fds[i], buf, sizeof(buf) - 1);
        
        /* Itt altalaban reszleges olvasas talalhato */
        if(res > 0)
        {
          buf[res] = '\0';
          printf("Pipe%d: %s", i+1, buf);
        } 
        else
        {
          perror("read");
          return 1;
        }
      }
    } 
  }
  return 0;
}

