#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>

#define BUFF_SIZE 1024

int main(int argc, char*argv[])
{
  int fd;
  int res;
  char buff[BUFF_SIZE];
  res = mkfifo(argv[1], 0600);
  if(res==-1)
  {
    perror("mkfifo");
    return -1;
  }
  fd = open (argv[1], O_RDONLY);
  if(fd == -1)
  {
    perror("open");
    return -1;
  }
  while((res = read(fd, buff, BUFF_SIZE-1)) !=0 )
  {
    if(res==-1)
    {
      if(errno == EINTR)
      {
        continue;
      }
      perror("read");
      break;
    }
    buff[res] = '\0';
    printf("%s\n", buff);
  }
  close(fd);
  return 0;
}

