#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/wait.h>

int main()
{
  int fds[2];
  pid_t pid;
  int res, i;
  int status;
  
  /* Letrehozunk egy uj csovezeteket */
  res = pipe (fds);
  if (res < 0) /* Ha nem sikerult */ 
  {
    perror("pipe");
    return -1;
  }
  
  /* Fork - uj processz letrehozasa */
  pid = fork();
  if (pid < 0) 
  {
    /* Sikertelen fork */
    perror ("fork");
    return -2;
  }
  if (pid == 0) 
  {
    /* A gyermekprocesszben vagyunk - itt csak irunk */
    close(fds[0]);
    for(i=0; i< 10; i++)
    {
      write(fds[1], &i, sizeof(int));
    }
    close(fds[1]);
    return 0; /* Gyermekprocessz kilep */
  }
  else 
  {
    /* A szuloprocesszben itt folytatjuk - itt csak olvasunk */
    close(fds[1]);
    while((res = read(fds[0], &i, sizeof(i)))>0)
    {
      printf("%d\n", i);
    }
    if(res < 0)
    {
      perror("read");
    }
    close(fds[0]);
  }
  
  wait(&status); /* Varunk a gyermekprocessz vegere */
  return 0; /* Szuloprocessz kilep */
}

