/* olvas.c – Standard bemenetrol olvas sorokat, es kiirja a
   kepernyore. */

#include <stdio.h>
#include <unistd.h>
#include <errno.h>

int main(void)
{
  char buf[1024];
  int len;

  /* Ha len > 0, akkor van kiirando adat. */
  while((len = read(STDIN_FILENO, buf, sizeof(buf))) != 0)
  {
    if(len == -1)
    {
      if(errno == EINTR)
      {
        continue; // Ujra megprobaljuk
      }
      perror("read");
      return -1;
    }
    if(write(STDOUT_FILENO, buf, len) == -1)
    {
      perror("write");
      return -1;
    }
  }
  return 0;
}

